<template>
  <div
    data-component-group="filter-forms"
    data-component="reports"
  >
    <FiltersForm
      :has-filters="hasFilters"
      @filter="onFilter"
      @clear="onClearFilters"
    >
      <v-autocomplete
        v-model="contract"
        :items="contracts"
        :filter="customFilter"
        prepend-inner-icon="receipt"
        :return-object="true"
        :item-text="getContractLabel"
        label="Contract"
        :menu-props="{nudgeBottom:'10'}"
      />

      <base-date-picker
        :date="dates"
        placeholder="Select date range"
        :config="dateConfig"
        :on-change="onChangeDate"
      />
    </FiltersForm>
  </div>
</template>

<script>
  import colors from 'vuetify/es5/util/colors';
  import FiltersForm from './Filters';
  import { isNum, isObj, isArr } from '../../../utils';

  // TODO: Translate component

  export default {
    components: {
      FiltersForm
    },
    data() {
      return {
        contract: {},
        dates: '',
        dateConfig: {
          mode: 'range'
        },
        colors
      };
    },
    computed: {
      contracts() {
        return this.$store.getters['reports/contracts'];
      },
      hasFilters() {
        const { contract, dates } = this;

        return isNum(contract.id)
          || dates !== '';
      }
    },
    created() {
      this.getContracts();
    },
    methods: {
      getContracts() {
        return this.$store.dispatch('reports/getContracts')
          .then((res) => {
            this.contract = res[0] || this.contract;
            this.onFilter();
            return res;
          });
      },
      onFilter() {
        const { contract, dates } = this;

        this.$emit('filter', {
          contract: contract.id,
          dates
        });
      },
      onClearFilters() {
        this.contract = {};
        this.dates = '';

        this.$emit('clearFilters');
      },
      customFilter(item, queryText) {
        const textOne = item.name.toLowerCase();
        const searchText = queryText.toLowerCase();

        return textOne.indexOf(searchText) > -1;
      },
      onChangeDate(dates) {
        this.dates = dates;
      },
      getContractLabel(item) {
        const { reports, business } = item;
        const statusLabel = isObj(business) ? business.status.name : '';
        const domainLabel = isArr(reports) && reports.length > 0 ? reports[0].domain : '';

        return `${item.contract_id}${domainLabel !== '' ? ` - ${domainLabel}` : ''}${statusLabel !== '' ? ` - ${statusLabel}` : ''}`;
      }
    }
  };
</script>

<style lang="stylus">
  [data-component-group="filter-forms"] {
    &[data-component="reports"] {
      h1 {
        display: flex;
        align-items: center;
        margin: 0 0 32px 0;
        min-height: 48px;
      }

      [data-component="filters"] {
        form {
          display: flex;
          justify-content: flex-start;
          align-items: center;

          > .v-input {
            width: calc(50% - 10px);
            padding-right: 10px;
          }

          [data-component="date-picker"] {
            width: 50%
          }
        }

        .component-actions {
          justify-content: flex-end !important;
          text-align: right;

          .v-btn {
            &.primary {
              margin-right: 20px;
            }
          }
        }
      }
    }
  }
</style>
